#ifdef RECOLA

#include "recola_drivers/compute_real_vbf_recola.f90"

#endif

************************************************************************
        subroutine Mat2photon_in1(p,m2i_phot,m2if_phot)
************************************************************************
*       squared amplitudes for 
*	photon(p1) + q(p2)    --> q'(p3)    + q''(p4) + H(p5) + q'''bar(p6)
*	photon(p1) + qbar(p2) --> q'bar(p3) + q''bar(p4) + H(p5) + q'''(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2photq(5,5,5,5),m2photqbar(5,5,5,5)
        real*8 m2i_phot(-5:5),m2if_phot(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for photon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

	dir(1) = +1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1

	do i1=0,3
	  k(1,i1) = p(3,i1)
	  k(2,i1) = p(2,i1)
	  k(3,i1) = p(6,i1)
	  k(4,i1) = p(4,i1)
	  k(5,i1) = p(5,i1)
	  k(6,i1) = p(1,i1)
	enddo

	call setprods4(k,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2photq(i1,i2,i3,i4)    = 0d0
	  m2photqbar(i1,i2,i3,i4) = 0d0
100	continue

c a-q --> q-q-qbar
	call Mat2aqq_phot(k,m2photq,1,2,3,4)

c other channels from CP symmetry for qcp=1
        if (qcp.eq.0) then
c a-qbar --> qbar-qbar-q
	call Mat2aqq_phot(k,m2photqbar,2,1,4,3)
        else
          do 103 i1=1,4
          do 103 i2=1,4
          do 103 i3=1,4
          do 103 i4=1,4
	    m2photqbar(i1,i2,i3,i4) = m2photq(i2,i1,i4,i3)
103       continue
        endif

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_phot( i1) = 0d0
          m2i_phot(-i1) = 0d0
        do 300 i2=1,4
        do 300 i3=1,4
        do 300 i4=1,4
          m2if_phot(i1,i2,i3,-i4) = m2photq(i2,i1,i4,i3)/2d0
          m2i_phot(i1) = m2i_phot(i1) + m2if_phot(i1,i2,i3,-i4)
          m2if_phot(-i1,-i2,-i3,i4) = m2photqbar(i1,i2,i3,i4)/2d0
          m2i_phot(-i1) = m2i_phot(-i1) + m2if_phot(-i1,-i2,-i3,i4)
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2photon_in2(p,m2i_phot,m2if_phot)
************************************************************************
*       squared amplitudes for 
*	q(p1)    + photon(p2) --> q'(p3)    + q''(p4) + H(p5) + q'''bar(p6)
*	qbar(p1) + photon(p2) --> q'bar(p3) + q''bar(p4) + H(p5) + q'''(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2photq(5,5,5,5),m2photqbar(5,5,5,5)
        real*8 m2i_phot(-5:5),m2if_phot(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for photon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

	dir(1) = +1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1

	do i1=0,3
	  k(1,i1) = p(3,i1)
	  k(2,i1) = p(1,i1)
	  k(3,i1) = p(6,i1)
	  k(4,i1) = p(4,i1)
	  k(5,i1) = p(5,i1)
	  k(6,i1) = p(2,i1)
	enddo

	call setprods4(k,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2photq(i1,i2,i3,i4)    = 0d0
	  m2photqbar(i1,i2,i3,i4) = 0d0
100	continue

c a-q --> q-q-qbar
	call Mat2aqq_phot(k,m2photq,1,2,3,4)

c other channels from CP symmetry for qcp=1
        if (qcp.eq.0) then
c a-qbar --> qbar-qbar-q
	  call Mat2aqq_phot(k,m2photqbar,2,1,4,3)
        else
          do 103 i1=1,4
          do 103 i2=1,4
          do 103 i3=1,4
          do 103 i4=1,4
	    m2photqbar(i1,i2,i3,i4) = m2photq(i2,i1,i4,i3)
103       continue
        endif

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_phot( i1) = 0d0
          m2i_phot(-i1) = 0d0
        do 300 i2=1,4
        do 300 i3=1,4
        do 300 i4=1,4
          m2if_phot(i1,i2,i3,-i4) = m2photq(i2,i1,i4,i3)/2d0
          m2i_phot(i1) = m2i_phot(i1) + m2if_phot(i1,i2,i3,-i4)
          m2if_phot(-i1,-i2,-i3,i4) = m2photqbar(i1,i2,i3,i4)/2d0
          m2i_phot(-i1) = m2i_phot(-i1) + m2if_phot(-i1,-i2,-i3,i4)
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2photon_out(p,m2i_phot,m2if_phot)
************************************************************************
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5) + photon(p6)
*-----------------------------------------------------------------------
*       10.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6)
	real*8 m2aqq_phot(5,5,5,5),m2qaq_phot(5,5,5,5)
        real*8 m2qq_phot(5,5,5,5),m2aqaq_phot(5,5,5,5)
        real*8 m2i_phot(-5:5,-5:5),m2if_phot(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	dir(1) = -1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = +1
	call setprods4(p,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2aqq_phot(i1,i2,i3,i4)  = 0d0
	  m2qq_phot(i1,i2,i3,i4)   = 0d0
	  m2qaq_phot(i1,i2,i3,i4)  = 0d0
	  m2aqaq_phot(i1,i2,i3,i4) = 0d0
100	continue

c qbar-q --> qbar-q
	call Mat2aqq_phot(p,m2aqq_phot,1,2,3,4)
c q-q    --> q-q
	call Mat2aqq_phot(p,m2qq_phot,3,2,1,4)

c Note: CP symmetry changes momenta p !
c q-qbar --> q-qbar
	call Mat2aqq_phot(p,m2qaq_phot,2,1,4,3)
c qbar-qbar --> qbar-qbar
	call Mat2aqq_phot(p,m2aqaq_phot,1,4,3,2)

c add final states for fixed initial states
        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i_phot(i1,i2) = 0d0
        do 300 i3=1,4
        do 300 i4=1,4
          if (i1*i2.eq.0) goto 200
          if ((i1.lt.0).and.(i2.gt.0)) then
            m2if_phot(i1,i2,-i3,i4) = m2aqq_phot(-i1,i2,i3,i4)
            m2i_phot(i1,i2) = m2i_phot(i1,i2) + m2if_phot(i1,i2,-i3,i4)
	  endif
          if ((i1.gt.0).and.(i2.lt.0)) then
            m2if_phot(i1,i2,i3,-i4) = m2qaq_phot(-i2,i1,i4,i3)
            m2i_phot(i1,i2) = m2i_phot(i1,i2) + m2if_phot(i1,i2,i3,-i4)
	  endif
          if ((i1.gt.0).and.(i2.gt.0)) then
            m2if_phot(i1,i2,i3,i4) = m2qq_phot(i3,i2,i1,i4)/2d0
            m2i_phot(i1,i2) = m2i_phot(i1,i2) + m2if_phot(i1,i2,i3,i4)
	  endif
          if ((i1.lt.0).and.(i2.lt.0)) then
            m2if_phot(i1,i2,-i3,-i4) = m2aqaq_phot(-i1,i4,i3,-i2)/2d0
            m2i_phot(i1,i2) = m2i_phot(i1,i2) + m2if_phot(i1,i2,-i3,-i4)
	  endif
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2aqq_phot(p,m2aqq_phot,q1,q2,q3,q4)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5) + photon(p6)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 mats,matt,wmats,wmatt
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 guu,gdd,gnn,gll     

        complex*16 msHWW4fa(-1:1),msHZZ4fa(-1:1,-1:1,-1:1)
        complex*16 mtHWW4fa(-1:1),mtHZZ4fa(-1:1,-1:1,-1:1)
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),m2aqq_phot(5,5,5,5)
	integer q1,q2,q3,q4
	integer ia,i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/prods4/sp,csp,vp

	el8 = el**8

c qbar-q scattering
c
c   s-channel:                             t-channel:
c
c   fa(p1) \_          / fd(p3)            fa(p1) --<--*--<-- fb(p3)
c          |\        |/                                >
c            \       /-                                >
c             *vvvvv*                                  >
c           _/       \                                 >
c           /|        \|                               >
c   fb(p2) /          -\ fc(p4)            fd(p2) -->--*-->-- fc(p4)

c Type: ubar-d -> ubar-d
c-----------------------

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
	if (qw.eq.1)
     &	  call M_WW_phot(msHWW4fa,qu,qd,qd,qu,q1,q2,q4,q3)    

c ubar-s -Z-> ubar-s    (k1->-p1,k2->p3,k3->p4,k4->-p2)   
	if (qz.eq.1)
     &	  call M_ZZ_phot(mtHZZ4fa,qu,qd,guu,gdd,q1,q3,q4,q2)

c*** individual channels
	do 200 i1=-1,1,2
	do 200 i2=-1,1,2
	do 200 i3=-1,1,2
	do 200 ia=-1,1,2
	  mats   = 0d0
	  matt   = 0d0
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1)) 
     &		         mats  = mats + msHWW4fa(ia)
	  if (i1.eq.-i3) matt  = matt + mtHZZ4fa(i3,i2,ia)

 	do 200 g1=1,2
 	do 200 g2=1,2
 	do 200 g3=1,2
 	do 200 g4=1,2
 	  wmats   = cv(g1,g2)*v(g3,g4)*mats
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4-1
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		         +qch2*9d0*(abs(wmats)**2+abs(matt)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats*dconjg(matt)) ) 
 	  else
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		+ qch2*9d0*abs(wmats)**2 )
 	  endif
200	continue

c Type: dbar-u -> dbar-u
c-----------------------

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if (qw.eq.1) call M_WW_phot(msHWW4fa,qu,qd,qd,qu,q4,q3,q1,q2)    

c dbar-c -Z-> dbar-c    (k3->-p1,k4->p3,k1->p4,k2->-p2)   
	if (qz.eq.1) call M_ZZ_phot(mtHZZ4fa,qu,qd,guu,gdd,q4,q2,q1,q3)

	do 205 i1=-1,1,2
	do 205 i2=-1,1,2
	do 205 i3=-1,1,2
	do 205 ia=-1,1,2
	  mats   = 0d0
	  matt   = 0d0
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1))
     &      	         mats = mats + msHWW4fa(ia)
	  if (i1.eq.-i3) matt = matt + mtHZZ4fa(i3,i2,ia)

 	do 205 g1=1,2
 	do 205 g2=1,2
 	do 205 g3=1,2
 	do 205 g4=1,2
 	  wmats = v(g2,g1)*cv(g4,g3)*mats
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		         +qch2*9d0*(abs(wmats)**2+abs(matt)**2) 
     &	                 -qchint*3d0*2d0*dreal(wmats*dconjg(matt)) )
 	  else
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		+ qch2*9d0*abs(wmats)**2 )
 	  endif
205	continue


c Type: ubar-u -> ubar-u
c----------------------- 

	if (qz.eq.1) then

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
     	  call M_ZZ_phot(msHZZ4fa,qu,qu,guu,guu,q1,q2,q4,q3)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
      	  call M_ZZ_phot(mtHZZ4fa,qu,qu,guu,guu,q1,q3,q4,q2)

	  do 201 i1=-1,1,2
	  do 201 i2=-1,1,2
	  do 201 i3=-1,1,2
	  do 201 ia=-1,1,2
	    mats   = 0d0
	    matt   = 0d0
	    if (i1.eq.-i2) mats = mats + msHZZ4fa(i2,i3,ia)
	    if (i1.eq.-i3) matt = matt + mtHZZ4fa(i3,i2,ia)
c*** ubar-u -ZZ-> ubar-u    
	    m2aqq_phot(2,2,2,2) = m2aqq_phot(2,2,2,2) + el8*(
     &		         +qch2*9d0*(abs(mats)**2+abs(matt)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats*dconjg(matt)) )
c*** ubar-u -Z-> cbar-c 
	    m2aqq_phot(2,2,4,4) = m2aqq_phot(2,2,4,4) + el8*(
     &		+ qch2*9d0*abs(mats)**2 )
c*** ubar-c -Z-> ubar-c 
	    m2aqq_phot(2,4,2,4) = m2aqq_phot(2,4,2,4) + el8*(
     &		+ qch2*9d0*abs(matt)**2 )
201	  continue
	  m2aqq_phot(4,4,4,4) = m2aqq_phot(2,2,2,2) 
	  m2aqq_phot(4,4,2,2) = m2aqq_phot(2,2,4,4)
	  m2aqq_phot(4,2,4,2) = m2aqq_phot(2,4,2,4)
	endif


c Type: ubar-u -> dbar-d
c----------------------- 

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (qz.eq.1) call M_ZZ_phot(msHZZ4fa,qu,qd,guu,gdd,q1,q2,q4,q3)

c ubar-u -W-> dbar-d  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (qw.eq.1) call M_WW_phot(mtHWW4fa,qu,qd,qd,qu,q1,q3,q4,q2)    

	do 202 i1=-1,1,2
	do 202 i2=-1,1,2
	do 202 i3=-1,1,2
	do 202 ia=-1,1,2
	  mats   = 0d0
	  matt   = 0d0
	  if (i1.eq.-i2) mats = mats + msHZZ4fa(i2,i3,ia)
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1)) 
     &      	         matt  = matt + mtHWW4fa(ia)

 	do 202 g1=1,2
 	do 202 g2=1,2
 	do 202 g3=1,2
 	do 202 g4=1,2
 	  wmatt = cv(g1,g3)*v(g2,g4)*matt
 	  f1 = 2*g1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4-1
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		          +qch2*9d0*(abs(wmatt)**2+abs(mats)**2) 
     &	                  -qchint*3d0*2d0*dreal(wmatt*dconjg(mats)) )
 	  else
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*(
     &		+  qch2*9d0*abs(wmatt)**2 ) 
 	  endif
202	  continue


c Type: dbar-d -> dbar-d
c-----------------------

	if (qz.eq.1) then

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
      	  call M_ZZ_phot(msHZZ4fa,qd,qd,gdd,gdd,q1,q2,q4,q3)

c dbar-s -Z-> dbar-s  (k1->-p1,k2->p3,k3->p4,k4->-p2)
      	  call M_ZZ_phot(mtHZZ4fa,qd,qd,gdd,gdd,q1,q3,q4,q2)

	  do 203 i1=-1,1,2
	  do 203 i2=-1,1,2
	  do 203 i3=-1,1,2
	  do 203 ia=-1,1,2
	    mats   = 0d0
	    matt   = 0d0
	    if (i1.eq.-i2) mats = mats + msHZZ4fa(i2,i3,ia)
	    if (i1.eq.-i3) matt = matt + mtHZZ4fa(i3,i2,ia)
c*** dbar-d -ZZ-> dbar-d    
	    m2aqq_phot(1,1,1,1) = m2aqq_phot(1,1,1,1) + el8*( 
     &		         +qch2*9d0*(abs(mats)**2+abs(matt)**2) 
     &	                 -qchint*3d0*2d0*dreal(mats*dconjg(matt)) ) 
c*** dbar-d -Z-> sbar-s 
	    m2aqq_phot(1,1,3,3) = m2aqq_phot(1,1,3,3) + el8*( 
     &		+ qch2*9d0*abs(mats)**2 )
c*** dbar-s -Z-> dbar-s 
	    m2aqq_phot(1,3,1,3) = m2aqq_phot(1,3,1,3) + el8*( 
     &		+ qch2*9d0*abs(matt)**2 )
203	  continue
	  m2aqq_phot(3,3,3,3) = m2aqq_phot(1,1,1,1) 
	  m2aqq_phot(3,3,1,1) = m2aqq_phot(1,1,3,3)
	  m2aqq_phot(3,1,3,1) = m2aqq_phot(1,3,1,3)
	endif


c Type: dbar-d -> ubar-u
c-----------------------

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
	if (qz.eq.1) call M_ZZ_phot(msHZZ4fa,qu,qd,guu,gdd,q4,q3,q1,q2)

c dbar-s -W-> ubar-c  (k3->-p1,k4->p3,k1->p4,k2->-p2)
	if (qw.eq.1) call M_WW_phot(mtHWW4fa,qu,qd,qd,qu,q4,q2,q1,q3)    

	do 204 i1=-1,1,2
	do 204 i2=-1,1,2
	do 204 i3=-1,1,2
	do 204 ia=-1,1,2
	  mats   = 0d0
	  matt   = 0d0
	  if (i1.eq.-i2) mats = mats + msHZZ4fa(i2,i3,ia)
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1))
     &	      	         matt = matt + mtHWW4fa(ia)

 	do 204 g1=1,2
 	do 204 g2=1,2
 	do 204 g3=1,2
 	do 204 g4=1,2
 	  wmatt = v(g3,g1)*cv(g4,g2)*matt
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*( 
     &		         + qch2*9d0*(abs(wmatt)**2+abs(mats)**2) 
     &	               	 - qchint*3d0*2d0*dreal(wmatt*dconjg(mats)) ) 
 	  else
 	    m2aqq_phot(f1,f2,f3,f4) = m2aqq_phot(f1,f2,f3,f4) + el8*( 
     &		+ qch2*9d0*abs(wmatt)**2 ) 
 	  endif
204	  continue

	end

************************************************************************
        subroutine setprods4(p,dir)
************************************************************************
*       Weyl-van der Waerden and Minkowski products
*-----------------------------------------------------------------------
*       14.3.2001 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 eiph(6),sp(6,6),csp(6,6)
        real*8 e(6),th(6),re(6),cth2(6),sth2(6),vp(6,6),p(6,0:3)
        integer i,j,k,dir(6)

        common/prods4/sp,csp,vp

        range(y) = max(min(y,1d0),-1d0)

        do 100 i=1,6
          e(i)    = p(i,0)
          re(i)   = sqrt(e(i))
          vect    = sqrt(p(i,1)**2+p(i,2)**2)
          vec     = sqrt(p(i,1)**2+p(i,2)**2+p(i,3)**2)
	  cth     = range( p(i,3)/vec )
	  sth     = vect/vec
	  if (cth.gt.0d0) then
            cth2(i) = sqrt((1d0+cth)/2d0)
	    sth2(i) = sth/2d0/cth2(i)
	  else
            sth2(i) = sqrt((1d0-cth)/2d0)
	    cth2(i) = sth/2d0/sth2(i)
	  endif
          if (abs(sth).lt.1d-10) then
            eiph(i) = 1d0
          else
            eiph(i) = dcmplx(p(i,1),p(i,2))/vec/sth
          endif
100     continue
        do 200 i=2,6
        do 200 j=1,i-1
           sp(i,j) = 2d0*re(i)*re(j)
     &               *(cth2(i)/eiph(i)*sth2(j)-sth2(i)*cth2(j)/eiph(j))
          csp(i,j) = dconjg(sp(i,j))*dir(i)*dir(j)
           vp(i,j) = sp(i,j)*csp(i,j)
           sp(j,i) = - sp(i,j)
          csp(j,i) = -csp(i,j)
           vp(j,i) =   vp(i,j)
200     continue

        end

************************************************************************
        subroutine M_ZZ_phot(mH4fa,qa,qc,gaz,gcz,fa,fb,fc,fd)
************************************************************************
*       Helicity amplitudes for 
*	H -> ZZ -> fa + fb-bar + fc + fd-bar + photon
*-----------------------------------------------------------------------
*       11.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 sp(6,6),csp(6,6)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pzab,pzcd,pzabp,pzcdp,cpzab,cpzcd,cpzabp,cpzcdp
        complex*16 Ammm,A(-1:1,-1:1,-1:1),mH4fa(-1:1,-1:1,-1:1)
        complex*16 gaz(-1:1),gcz(-1:1),fac
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(6,6)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkab,checkcd

        common/prods4/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	Ammm(qa,qc,ia,ib,ic,id,pzab,pzcd,pzabp,pzcdp) = csp(ib,id) *(
     &	  qa*pzabp*pzcd*(csp(ia,ib)*sp(ia,ic)+csp(6,ib)*sp(6,ic))
     &	    /csp(6,ia)/csp(6,ib)
     &	 -qc*pzab*pzcdp*(csp(ic,id)*sp(ic,ia)+csp(6,id)*sp(6,ia))
     &	    /csp(6,ic)/csp(6,id) )

	sab  = vp(fa,fb)
	scd  = vp(fc,fd)
	sabp = vp(fa,fb) + vp(fa,6) + vp(fb,6)
	scdp = vp(fc,fd) + vp(fc,6) + vp(fd,6)

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pzab = 1d0/(sab-mz2)
        else
          pzab = 1d0/(sab-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pzcd = 1d0/(scd-mz2)
        else
          pzcd = 1d0/(scd-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sabp.lt.0d0))) then
          pzabp = 1d0/(sabp-mz2)
        else
          pzabp = 1d0/(sabp-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scdp.lt.0d0))) then
          pzcdp = 1d0/(scdp-mz2)
        else
          pzcdp = 1d0/(scdp-cmz2)
        endif

	checkab = ((qschan.eq.1).and.(sab.gt.0d0).and.(scdp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scdp.lt.0d0))
	checkcd = ((qschan.eq.1).and.(scd.gt.0d0).and.(sabp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(scd.lt.0d0).and.(sabp.lt.0d0))

	if (.not.checkab) pzab = 0d0
	if (.not.checkcd) pzcd = 0d0

	cpzab  = dconjg(pzab)
	cpzabp = dconjg(pzabp)
	cpzcd  = dconjg(pzcd)
	cpzcdp = dconjg(pzcdp)

	A(-1,-1,-1) = Ammm( qa, qc,fa,fb,fc,fd,pzab,pzcd,pzabp,pzcdp)
	A(+1,-1,-1) = Ammm(-qa, qc,fb,fa,fc,fd,pzab,pzcd,pzabp,pzcdp)
	A(-1,+1,-1) = Ammm( qa,-qc,fa,fb,fd,fc,pzab,pzcd,pzabp,pzcdp)
	A(+1,+1,-1) = Ammm(-qa,-qc,fb,fa,fd,fc,pzab,pzcd,pzabp,pzcdp)
	A(+1,+1,+1) = 
     &	  dconjg(Ammm( qa, qc,fa,fb,fc,fd,cpzab,cpzcd,cpzabp,cpzcdp))
	A(-1,+1,+1) = 
     &	  dconjg(Ammm(-qa, qc,fb,fa,fc,fd,cpzab,cpzcd,cpzabp,cpzcdp))
	A(+1,-1,+1) = 
     &	  dconjg(Ammm( qa,-qc,fa,fb,fd,fc,cpzab,cpzcd,cpzabp,cpzcdp))
	A(-1,-1,+1) = 
     &	  dconjg(Ammm(-qa,-qc,fb,fa,fd,fc,cpzab,cpzcd,cpzabp,cpzcdp))

	fac = 2d0*sqrt(2d0)*xmw/xcw2/xsw

	do i1=-1,1,2
	do i2=-1,1,2
	do i3=-1,1,2
	  mH4fa(i1,i2,i3) = fac*gaz(i1)*gcz(i2)*A(i1,i2,i3)
	enddo
	enddo
	enddo

	end

************************************************************************
        subroutine M_WW_phot(mH4fa,qa,qb,qc,qd,fa,fb,fc,fd)
************************************************************************
*       Helicity amplitudes for 
*	H -> WW(+photon) -> fa + fb-bar + fc + fd-bar + photon
*-----------------------------------------------------------------------
*       18.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 sp(6,6),csp(6,6)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pwab,pwcd,pwabp,pwcdp,cpwab,cpwcd,cpwabp,cpwcdp
        complex*16 Am,A(-1:1),mH4fa(-1:1)
        complex*16 fac
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(6,6)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkab,checkcd

        common/prods4/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	Am(qa,qb,qc,qd,ia,ib,ic,id,pwab,pwcd,pwabp,pwcdp) = csp(ib,id)*(
     &	    pwabp*pwcd*(csp(ia,ib)*sp(ia,ic)+csp(6,ib)*sp(6,ic))
     &	      *( qa/csp(6,ia)/csp(6,ib)
     &	        +(qa-qb)*sp(6,ia)/csp(6,ib)*pwab )
     &	   -pwab*pwcdp*(csp(ic,id)*sp(ic,ia)+csp(6,id)*sp(6,ia))
     &	      *( qc/csp(6,ic)/csp(6,id) 
     &		+(qc-qd)*sp(6,ic)/csp(6,id)*pwcd )
     &	   +(qa-qb)*pwab*pwcd*csp(ib,id)*sp(ia,ic)/csp(6,ib)/csp(6,id) )

	sab  = vp(fa,fb)
	scd  = vp(fc,fd)
	sabp = vp(fa,fb) + vp(fa,6) + vp(fb,6)
	scdp = vp(fc,fd) + vp(fc,6) + vp(fd,6)

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pwab = 1d0/(sab-mw2)
        else
          pwab = 1d0/(sab-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pwcd = 1d0/(scd-mw2)
        else
          pwcd = 1d0/(scd-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sabp.lt.0d0))) then
          pwabp = 1d0/(sabp-mw2)
        else
          pwabp = 1d0/(sabp-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scdp.lt.0d0))) then
          pwcdp = 1d0/(scdp-mw2)
        else
          pwcdp = 1d0/(scdp-cmw2)
        endif

	checkab = ((qschan.eq.1).and.(sab.gt.0d0).and.(scdp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scdp.lt.0d0))
	checkcd = ((qschan.eq.1).and.(scd.gt.0d0).and.(sabp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(scd.lt.0d0).and.(sabp.lt.0d0))

	if (.not.checkab) pwab = 0d0
	if (.not.checkcd) pwcd = 0d0

	cpwab  = dconjg(pwab)
	cpwabp = dconjg(pwabp)
	cpwcd  = dconjg(pwcd)
	cpwcdp = dconjg(pwcdp)

	A(-1) = Am(qa,qb,qc,qd,fa,fb,fc,fd,pwab,pwcd,pwabp,pwcdp)
	A(+1) = 
     &	  -dconjg(Am(qd,qc,qb,qa,fd,fc,fb,fa,cpwcd,cpwab,cpwcdp,cpwabp))

	fac = sqrt(2d0)*xmw/xsw**3

	do i1=-1,1,2
	  mH4fa(i1) = fac*A(i1)
	enddo

	end

************************************************************************
        subroutine Mat2gluon_in1(p,m2i_gluon,m2if_gluon)
************************************************************************
*       squared amplitudes for 
*	gluon(p1) + q(p2)    --> q'(p3)    + q''(p4) + H(p5) + q'''bar(p6)
*	gluon(p1) + qbar(p2) --> q'bar(p3) + q''bar(p4) + H(p5) + q'''(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2gluonq(5,5,5,5),m2gluonqbar(5,5,5,5)
        real*8 m2i_gluon(-5:5),m2if_gluon(-5:5,-5:5,-5:5,-5:5)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer i1,i2,i3,i4,dir(6)

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	dir(1) = +1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1

	do i1=0,3
	  k(1,i1) = p(3,i1)
	  k(2,i1) = p(2,i1)
	  k(3,i1) = p(6,i1)
	  k(4,i1) = p(4,i1)
	  k(5,i1) = p(5,i1)
	  k(6,i1) = p(1,i1)
	enddo

	call setprods4(k,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2gluonq(i1,i2,i3,i4)    = 0d0
	  m2gluonqbar(i1,i2,i3,i4) = 0d0
100	continue

c a-q --> q-q-qbar
	call Mat2aqq_gluon(k,m2gluonq,1,2,3,4)

c other channels from CP symmetry for qcp=1
        if (qcp.eq.0) then
c a-qbar --> qbar-qbar-q
	  call Mat2aqq_gluon(k,m2gluonqbar,2,1,4,3)
        else
          do 103 i1=1,4
          do 103 i2=1,4
          do 103 i3=1,4
          do 103 i4=1,4
	    m2gluonqbar(i1,i2,i3,i4) = m2gluonq(i2,i1,i4,i3)
103       continue
        endif

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_gluon( i1) = 0d0
          m2i_gluon(-i1) = 0d0
        do 300 i2=1,4
        do 300 i3=1,4
        do 300 i4=1,4
          m2if_gluon(i1,i2,i3,-i4) = m2gluonq(i2,i1,i4,i3)/2d0
          m2i_gluon(i1) = m2i_gluon(i1) + m2if_gluon(i1,i2,i3,-i4)
          m2if_gluon(-i1,-i2,-i3,i4) = m2gluonqbar(i1,i2,i3,i4)/2d0
          m2i_gluon(-i1) = m2i_gluon(-i1) + m2if_gluon(-i1,-i2,-i3,i4)
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2gluon_in2(p,m2i_gluon,m2if_gluon)
************************************************************************
*       squared amplitudes for 
*	q(p1)    + gluon(p2) --> q'(p3)    + q''(p4) + H(p5) + q'''bar(p6)
*	qbar(p1) + gluon(p2) --> q'bar(p3) + q''bar(p4) + H(p5) + q'''(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2gluonq(5,5,5,5),m2gluonqbar(5,5,5,5)
        real*8 m2i_gluon(-5:5),m2if_gluon(-5:5,-5:5,-5:5,-5:5)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer i1,i2,i3,i4,dir(6)

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	dir(1) = +1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1

	do i1=0,3
	  k(1,i1) = p(3,i1)
	  k(2,i1) = p(1,i1)
	  k(3,i1) = p(6,i1)
	  k(4,i1) = p(4,i1)
	  k(5,i1) = p(5,i1)
	  k(6,i1) = p(2,i1)
	enddo

	call setprods4(k,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2gluonq(i1,i2,i3,i4)    = 0d0
	  m2gluonqbar(i1,i2,i3,i4) = 0d0
100	continue

c a-q --> q-q-qbar
	call Mat2aqq_gluon(k,m2gluonq,1,2,3,4)

c other channels from CP symmetry for qcp=1
        if (qcp.eq.0) then
c a-qbar --> qbar-qbar-q
	  call Mat2aqq_gluon(k,m2gluonqbar,2,1,4,3)
        else
          do 103 i1=1,4
          do 103 i2=1,4
          do 103 i3=1,4
          do 103 i4=1,4
	    m2gluonqbar(i1,i2,i3,i4) = m2gluonq(i2,i1,i4,i3)
103       continue
        endif

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_gluon( i1) = 0d0
          m2i_gluon(-i1) = 0d0
        do 300 i2=1,4
        do 300 i3=1,4
        do 300 i4=1,4
          m2if_gluon(i1,i2,i3,-i4) = m2gluonq(i2,i1,i4,i3)/2d0
          m2i_gluon(i1) = m2i_gluon(i1) + m2if_gluon(i1,i2,i3,-i4)
          m2if_gluon(-i1,-i2,-i3,i4) = m2gluonqbar(i1,i2,i3,i4)/2d0
          m2i_gluon(-i1) = m2i_gluon(-i1) + m2if_gluon(-i1,-i2,-i3,i4)
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2gluon_out(p,m2i_gluon,m2if_gluon)
************************************************************************
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5) + gluon(p6)
*-----------------------------------------------------------------------
*       19.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6)
	real*8 m2aqq_gluon(5,5,5,5),m2qaq_gluon(5,5,5,5)
        real*8 m2qq_gluon(5,5,5,5),m2aqaq_gluon(5,5,5,5)
        real*8 m2i_gluon(-5:5,-5:5),m2if_gluon(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp

	dir(1) = -1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = +1
	call setprods4(p,dir)

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	do 100 i3=1,4
	do 100 i4=1,4
	  m2aqq_gluon(i1,i2,i3,i4)  = 0d0
	  m2qq_gluon(i1,i2,i3,i4)   = 0d0
	  m2qaq_gluon(i1,i2,i3,i4)  = 0d0
	  m2aqaq_gluon(i1,i2,i3,i4) = 0d0
100	continue

c qbar-q --> qbar-q
	call Mat2aqq_gluon(p,m2aqq_gluon,1,2,3,4)
c q-qbar --> q-qbar
	call Mat2aqq_gluon(p,m2qaq_gluon,2,1,4,3)
c q-q    --> q-q
	call Mat2aqq_gluon(p,m2qq_gluon,3,2,1,4)
c qbar-qbar --> qbar-qbar
	call Mat2aqq_gluon(p,m2aqaq_gluon,1,4,3,2)

c add final states for fixed initial states
        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i_gluon(i1,i2) = 0d0
        do 300 i3=1,4
        do 300 i4=1,4
          if (i1*i2.eq.0) goto 200
          if ((i1.lt.0).and.(i2.gt.0)) then
            m2if_gluon(i1,i2,-i3,i4) = m2aqq_gluon(-i1,i2,i3,i4)
            m2i_gluon(i1,i2)=m2i_gluon(i1,i2)+m2if_gluon(i1,i2,-i3,i4)
	  endif
          if ((i1.gt.0).and.(i2.lt.0)) then
            m2if_gluon(i1,i2,i3,-i4) = m2qaq_gluon(-i2,i1,i4,i3)
            m2i_gluon(i1,i2)=m2i_gluon(i1,i2)+m2if_gluon(i1,i2,i3,-i4)
	  endif
          if ((i1.gt.0).and.(i2.gt.0)) then
            m2if_gluon(i1,i2,i3,i4) = m2qq_gluon(i3,i2,i1,i4)/2d0
            m2i_gluon(i1,i2)=m2i_gluon(i1,i2)+m2if_gluon(i1,i2,i3,i4)
	  endif
          if ((i1.lt.0).and.(i2.lt.0)) then
            m2if_gluon(i1,i2,-i3,-i4) = m2aqaq_gluon(-i1,i4,i3,-i2)/2d0
            m2i_gluon(i1,i2)=m2i_gluon(i1,i2)+m2if_gluon(i1,i2,-i3,-i4)
	  endif
300     continue
200     continue

	end

************************************************************************
        subroutine Mat2aqq_gluon(p,m2aqq_gluon,q1,q2,q3,q4)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5) + gluon(p6)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 mats1,matt1,wmats1,wmatt1
	complex*16 mats2,matt2,wmats2,wmatt2
	complex*16 mats1hvv,matt1hvv,wmats1hvv,wmatt1hvv
	complex*16 mats2hvv,matt2hvv,wmats2hvv,wmatt2hvv
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 guu,gdd,gnn,gll     
        complex*16 msHWW4fg1(-1:1),msHWW4fg2(-1:1)
	complex*16 mtHWW4fg1(-1:1),mtHWW4fg2(-1:1)
	complex*16 msHZZ4fg1(-1:1,-1:1,-1:1),msHZZ4fg2(-1:1,-1:1,-1:1)
	complex*16 mtHZZ4fg1(-1:1,-1:1,-1:1),mtHZZ4fg2(-1:1,-1:1,-1:1)
        complex*16 msHWW4fg1hvv(-1:1),msHWW4fg2hvv(-1:1)
	complex*16 mtHWW4fg1hvv(-1:1),mtHWW4fg2hvv(-1:1)
	complex*16 msHZZ4fg1hvv(-1:1,-1:1,-1:1)
	complex*16 msHZZ4fg2hvv(-1:1,-1:1,-1:1)
	complex*16 mtHZZ4fg1hvv(-1:1,-1:1,-1:1)
	complex*16 mtHZZ4fg2hvv(-1:1,-1:1,-1:1)
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),m2aqq_gluon(5,5,5,5)
	integer q1,q2,q3,q4
	integer ig,i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/prods4/sp,csp,vp
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

	gs2el6 = el**6*4d0*pi*alphas

c qbar-q scattering
c
c   s-channel:                             t-channel:
c
c   fa(p1) \_          / fd(p3)            fa(p1) --<--*--<-- fb(p3)
c          |\        |/                                >
c            \       /-                                >
c             *vvvvv*                                  >
c           _/       \                                 >
c           /|        \|                               >
c   fb(p2) /          -\ fc(p4)            fd(p2) -->--*-->-- fc(p4)

c Type: ubar-d -> ubar-d
c-----------------------

c ubar-d -W-> cbar-s    (k1->-p1,k2->-p2,k3->p4,k4->p3)   
	if (qw.eq.1) then
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) 
     &	    call M_WW_gluon(msHWW4fg1,msHWW4fg2,q1,q2,q4,q3,0)    
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) 
     &	    call M_WW_gluon(msHWW4fg1hvv,msHWW4fg2hvv,q1,q2,q4,q3,qhvv)    
	else
	  do i1=-1,1,2
	    msHWW4fg1(i1)    = 0d0
	    msHWW4fg2(i1)    = 0d0
	    msHWW4fg1hvv(i1) = 0d0
	    msHWW4fg2hvv(i1) = 0d0
	  enddo
	endif

c ubar-s -Z-> ubar-s    (k1->-p1,k2->p3,k3->p4,k4->-p2)   
	if (qz.eq.1) then
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	                mtHZZ4fg1,mtHZZ4fg2,guu,gdd,qu,qd,q1,q3,q4,q2,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &	       mtHZZ4fg1hvv,mtHZZ4fg2hvv,guu,gdd,qu,qd,q1,q3,q4,q2,qhvv)
	else
	  do i1=-1,1,2
	  do i2=-1,1,2
	  do i3=-1,1,2
	    mtHZZ4fg1(i1,i2,i3)    = 0d0
	    mtHZZ4fg2(i1,i2,i3)    = 0d0
	    mtHZZ4fg1hvv(i1,i2,i3) = 0d0
	    mtHZZ4fg2hvv(i1,i2,i3) = 0d0
	  enddo
	  enddo
	  enddo
	endif

c*** individual channels
	do 200 i1=-1,1,2
	do 200 i2=-1,1,2
	do 200 i3=-1,1,2
	do 200 ig=-1,1,2
	  mats1 = 0d0
	  matt1 = 0d0
	  mats2 = 0d0
	  matt2 = 0d0
	  mats1hvv = 0d0
	  matt1hvv = 0d0
	  mats2hvv = 0d0
	  matt2hvv = 0d0
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1))then
      	    mats1 = mats1 + msHWW4fg1(ig)
      	    mats2 = mats2 + msHWW4fg2(ig)
            if (qhvv.ne.0) then
      	      mats1hvv = mats1hvv + msHWW4fg1hvv(ig)
      	      mats2hvv = mats2hvv + msHWW4fg2hvv(ig)
	    endif
	  endif
	  if (i1.eq.-i3) then
      	    matt1 = matt1 + mtHZZ4fg1(i3,i2,ig)
      	    matt2 = matt2 + mtHZZ4fg2(i3,i2,ig)
            if (qhvv.ne.0) then
      	      matt1hvv = matt1hvv + mtHZZ4fg1hvv(i3,i2,ig)
      	      matt2hvv = matt2hvv + mtHZZ4fg2hvv(i3,i2,ig)
	    endif
	  endif

 	do 200 g1=1,2
 	do 200 g2=1,2
 	do 200 g3=1,2
 	do 200 g4=1,2
 	  wmats1  = cv(g1,g2)*v(g3,g4)*mats1
 	  wmats2  = cv(g1,g2)*v(g3,g4)*mats2
          if (qhvv.ne.0) then
 	    wmats1hvv  = cv(g1,g2)*v(g3,g4)*mats1hvv
 	    wmats2hvv  = cv(g1,g2)*v(g3,g4)*mats2hvv
	  endif
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4-1
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmats1)**2+abs(wmats2)**2
     &		                    +abs(matt1)**2 +abs(matt2)**2 )
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmats1hvv)**2+abs(wmats2hvv)**2
     &	  	                    +abs(matt1hvv)**2 +abs(matt2hvv)**2)  
	    endif
	    if (qqcdnondiag.eq.1)
     &	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*(-qchint*8d0*dreal( wmats1*dconjg(matt1)
     &		                            +wmats1*dconjg(matt2)
     &		                            +wmats2*dconjg(matt1)
     &		                            +wmats2*dconjg(matt2) ) )
 	  else
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmats1)**2+abs(wmats2)**2)
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmats1hvv)**2+abs(wmats2hvv)**2)
 	    endif
 	  endif
200	continue


c Type: dbar-u -> dbar-u
c-----------------------

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	if (qw.eq.1) then
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) 
     &	    call M_WW_gluon(msHWW4fg1,msHWW4fg2,q4,q3,q1,q2,0)    
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) 
     &	    call M_WW_gluon(msHWW4fg1hvv,msHWW4fg2hvv,q4,q3,q1,q2,qhvv)    
	else
	  do i1=-1,1,2
	    msHWW4fg1(i1)    = 0d0
	    msHWW4fg2(i1)    = 0d0
	    msHWW4fg1hvv(i1) = 0d0
	    msHWW4fg2hvv(i1) = 0d0
	  enddo
	endif

c dbar-c -Z-> dbar-c    (k3->-p1,k4->p3,k1->p4,k2->-p2)   
	if (qz.eq.1) then
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	     mtHZZ4fg1,mtHZZ4fg2,guu,gdd,qu,qd,q4,q2,q1,q3,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &       mtHZZ4fg1hvv,mtHZZ4fg2hvv,guu,gdd,qu,qd,q4,q2,q1,q3,qhvv)
	else
	  do i1=-1,1,2
	  do i2=-1,1,2
	  do i3=-1,1,2
	    mtHZZ4fg1(i1,i2,i3)    = 0d0
	    mtHZZ4fg2(i1,i2,i3)    = 0d0
	    mtHZZ4fg1hvv(i1,i2,i3) = 0d0
	    mtHZZ4fg2hvv(i1,i2,i3) = 0d0
	  enddo
	  enddo
	  enddo
	endif

	do 205 i1=-1,1,2
	do 205 i2=-1,1,2
	do 205 i3=-1,1,2
	do 205 ig=-1,1,2
	  mats1   = 0d0
	  matt1   = 0d0
	  mats2   = 0d0
	  matt2   = 0d0
	  mats1hvv = 0d0
	  matt1hvv = 0d0
	  mats2hvv = 0d0
	  matt2hvv = 0d0
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1)) then
      	    mats1  = mats1 + msHWW4fg1(ig)
      	    mats2  = mats2 + msHWW4fg2(ig)
            if (qhvv.ne.0) then
      	      mats1hvv  = mats1hvv + msHWW4fg1hvv(ig)
      	      mats2hvv  = mats2hvv + msHWW4fg2hvv(ig)
	    endif
	  endif
	  if (i1.eq.-i3) then
      	    matt1 = matt1 + mtHZZ4fg1(i3,i2,ig)
      	    matt2 = matt2 + mtHZZ4fg2(i3,i2,ig)
            if (qhvv.ne.0) then
      	      matt1hvv  = matt1hvv + mtHZZ4fg1hvv(i3,i2,ig)
      	      matt2hvv  = matt2hvv + mtHZZ4fg2hvv(i3,i2,ig)
	    endif
	  endif

 	do 205 g1=1,2
 	do 205 g2=1,2
 	do 205 g3=1,2
 	do 205 g4=1,2
 	  wmats1 = v(g2,g1)*cv(g4,g3)*mats1
 	  wmats2 = v(g2,g1)*cv(g4,g3)*mats2
          if (qhvv.ne.0) then
 	    wmats1hvv = v(g2,g1)*cv(g4,g3)*mats1hvv
 	    wmats2hvv = v(g2,g1)*cv(g4,g3)*mats2hvv
	  endif
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4
 	  if ((f1.eq.f3).and.(f2.eq.f4)) then
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmats1)**2+abs(wmats2)**2 
     &		                    +abs(matt1)**2 +abs(matt2)**2 )
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmats1hvv)**2+abs(wmats2hvv)**2 
     &		                    +abs(matt1hvv)**2 +abs(matt2hvv)**2)
	    endif
	    if (qqcdnondiag.eq.1)
     &	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*(-qchint*8d0*dreal( wmats1*dconjg(matt1)
     &		                            +wmats1*dconjg(matt2)
     &		                            +wmats2*dconjg(matt1)
     &		                            +wmats2*dconjg(matt2) ))
 	  else
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmats1)**2+abs(wmats2)**2)
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmats1hvv)**2+abs(wmats2hvv)**2)
 	    endif
 	  endif
205	continue


c Type: ubar-u -> ubar-u
c----------------------- 

	if (qz.eq.1) then

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	      msHZZ4fg1,msHZZ4fg2,guu,guu,qu,qu,q1,q2,q4,q3,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &	      msHZZ4fg1hvv,msHZZ4fg2hvv,guu,guu,qu,qu,q1,q2,q4,q3,qhvv)

c ubar-c -Z-> ubar-c  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	     mtHZZ4fg1,mtHZZ4fg2,guu,guu,qu,qu,q1,q3,q4,q2,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &	     mtHZZ4fg1hvv,mtHZZ4fg2hvv,guu,guu,qu,qu,q1,q3,q4,q2,qhvv)

	  do 201 i1=-1,1,2
	  do 201 i2=-1,1,2
	  do 201 i3=-1,1,2
	  do 201 ig=-1,1,2
	    mats1   = 0d0
	    matt1   = 0d0
	    mats2   = 0d0
	    matt2   = 0d0
	    mats1hvv = 0d0
	    matt1hvv = 0d0
	    mats2hvv = 0d0
	    matt2hvv = 0d0
	    if (i1.eq.-i2) then
      	      mats1 = mats1 + msHZZ4fg1(i2,i3,ig)
      	      mats2 = mats2 + msHZZ4fg2(i2,i3,ig)
              if (qhvv.ne.0) then
      	        mats1hvv = mats1hvv + msHZZ4fg1hvv(i2,i3,ig)
      	        mats2hvv = mats2hvv + msHZZ4fg2hvv(i2,i3,ig)
	      endif
	    endif
	    if (i1.eq.-i3) then
      	      matt1 = matt1 + mtHZZ4fg1(i3,i2,ig)
      	      matt2 = matt2 + mtHZZ4fg2(i3,i2,ig)
              if (qhvv.ne.0) then
      	        matt1hvv = matt1hvv + mtHZZ4fg1hvv(i3,i2,ig)
      	        matt2hvv = matt2hvv + mtHZZ4fg2hvv(i3,i2,ig)
	      endif
	    endif
c*** ubar-u -ZZ-> ubar-u    
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,2,2,2) = m2aqq_gluon(2,2,2,2) 
     &	        + gs2el6*qch2*12d0*( abs(mats1)**2+abs(mats2)**2 
     &		                    +abs(matt1)**2+abs(matt2)**2 ) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,2,2,2) = m2aqq_gluon(2,2,2,2) 
     &	        + gs2el6*qch2*12d0*( abs(mats1hvv)**2+abs(mats2hvv)**2 
     &		                    +abs(matt1hvv)**2+abs(matt2hvv)**2 ) 
	    endif
	    if (qqcdnondiag.eq.1)
     &	       m2aqq_gluon(2,2,2,2) = m2aqq_gluon(2,2,2,2) 
     &	         + gs2el6*(-qchint*8d0*dreal( mats1*dconjg(matt1)
     &		                             +mats1*dconjg(matt2)
     &		                             +mats2*dconjg(matt1)
     &		                             +mats2*dconjg(matt2) ))
c*** ubar-u -Z-> cbar-c 
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,2,4,4) = m2aqq_gluon(2,2,4,4) 
     &	        + gs2el6*qch2*12d0*(abs(mats1)**2+abs(mats2)**2) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,2,4,4) = m2aqq_gluon(2,2,4,4) 
     &	        + gs2el6*qch2*12d0*(abs(mats1hvv)**2+abs(mats2hvv)**2) 
	    endif
c*** ubar-c -Z-> ubar-c 
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,4,2,4) = m2aqq_gluon(2,4,2,4) 
     &	        + gs2el6*qch2*12d0*(abs(matt1)**2+abs(matt2)**2)
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(2,4,2,4) = m2aqq_gluon(2,4,2,4) 
     &	        + gs2el6*qch2*12d0*(abs(matt1hvv)**2+abs(matt2hvv)**2)
	    endif
201	  continue
	  m2aqq_gluon(4,4,4,4) = m2aqq_gluon(2,2,2,2) 
	  m2aqq_gluon(4,4,2,2) = m2aqq_gluon(2,2,4,4)
	  m2aqq_gluon(4,2,4,2) = m2aqq_gluon(2,4,2,4)
	endif


c Type: ubar-u -> dbar-d
c----------------------- 

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	if (qz.eq.1) then
	  if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &       msHZZ4fg1,msHZZ4fg2,guu,gdd,qu,qd,q1,q2,q4,q3,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &       msHZZ4fg1hvv,msHZZ4fg2hvv,guu,gdd,qu,qd,q1,q2,q4,q3,qhvv)
	else
	  do i1=-1,1,2
	  do i2=-1,1,2
	  do i3=-1,1,2
	    msHZZ4fg1(i1,i2,i3)    = 0d0
	    msHZZ4fg2(i1,i2,i3)    = 0d0
	    msHZZ4fg1hvv(i1,i2,i3) = 0d0
	    msHZZ4fg2hvv(i1,i2,i3) = 0d0
	  enddo
	  enddo
	  enddo
	endif

c ubar-u -W-> dbar-d  (k1->-p1,k2->p3,k3->p4,k4->-p2)
	if (qw.eq.1) then
          if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) 
     &	    call M_WW_gluon(mtHWW4fg1,mtHWW4fg2,q1,q3,q4,q2,0)    
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) 
     &	    call M_WW_gluon(mtHWW4fg1hvv,mtHWW4fg2hvv,q1,q3,q4,q2,qhvv)    
	else
	  do i1=-1,1,2
	    mtHWW4fg1(i1)    = 0d0
	    mtHWW4fg2(i1)    = 0d0
	    mtHWW4fg1hvv(i1) = 0d0
	    mtHWW4fg2hvv(i1) = 0d0
	  enddo
	endif

	do 202 i1=-1,1,2
	do 202 i2=-1,1,2
	do 202 i3=-1,1,2
	do 202 ig=-1,1,2
	  mats1   = 0d0
	  matt1   = 0d0
	  mats2   = 0d0
	  matt2   = 0d0
	  mats1hvv = 0d0
	  matt1hvv = 0d0
	  mats2hvv = 0d0
	  matt2hvv = 0d0
	  if (i1.eq.-i2) then
      	    mats1 = mats1 + msHZZ4fg1(i2,i3,ig)
      	    mats2 = mats2 + msHZZ4fg2(i2,i3,ig)
            if (qhvv.ne.0) then
      	      mats1hvv = mats1hvv + msHZZ4fg1hvv(i2,i3,ig)
      	      mats2hvv = mats2hvv + msHZZ4fg2hvv(i2,i3,ig)
	    endif
	  endif
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1))then
      	    matt1  = matt1 + mtHWW4fg1(ig)
      	    matt2  = matt2 + mtHWW4fg2(ig)
            if (qhvv.ne.0) then
      	      matt1hvv  = matt1hvv + mtHWW4fg1hvv(ig)
      	      matt2hvv  = matt2hvv + mtHWW4fg2hvv(ig)
	    endif
	  endif

 	do 202 g1=1,2
 	do 202 g2=1,2
 	do 202 g3=1,2
 	do 202 g4=1,2
 	  wmatt1 = cv(g1,g3)*v(g2,g4)*matt1
 	  wmatt2 = cv(g1,g3)*v(g2,g4)*matt2
          if (qhvv.ne.0) then
 	    wmatt1hvv = cv(g1,g3)*v(g2,g4)*matt1hvv
 	    wmatt2hvv = cv(g1,g3)*v(g2,g4)*matt2hvv
 	  endif
 	  f1 = 2*g1
 	  f2 = 2*g2
 	  f3 = 2*g3-1
 	  f4 = 2*g4-1
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*(+qch2*12d0*( abs(wmatt1)**2+abs(wmatt2)**2 
     &		                      +abs(mats1)**2 +abs(mats2)**2 )) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmatt1hvv)**2+abs(wmatt2hvv)**2 
     &		                    +abs(mats1hvv)**2 +abs(mats2hvv)**2)
	    endif
	    if (qqcdnondiag.eq.1)
     &	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	         + gs2el6*(-qchint*8d0*dreal( mats1*dconjg(wmatt1)
     &		                             +mats1*dconjg(wmatt2)
     &		                             +mats2*dconjg(wmatt1)
     &		                             +mats2*dconjg(wmatt2) ))
 	  else
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4)
     &	        + gs2el6*qch2*12d0*(abs(wmatt1)**2+abs(wmatt2)**2)
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4)
     &	        + gs2el6*qch2*12d0*(abs(wmatt1hvv)**2+abs(wmatt2hvv)**2)
 	    endif
 	  endif
202	  continue


c Type: dbar-d -> dbar-d
c-----------------------

	if (qz.eq.1) then

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
          if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	     msHZZ4fg1,msHZZ4fg2,gdd,gdd,qd,qd,q1,q2,q4,q3,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &	     msHZZ4fg1hvv,msHZZ4fg2hvv,gdd,gdd,qd,qd,q1,q2,q4,q3,qhvv)

c dbar-s -Z-> dbar-s  (k1->-p1,k2->p3,k3->p4,k4->-p2)
          if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &       mtHZZ4fg1,mtHZZ4fg2,gdd,gdd,qd,qd,q1,q3,q4,q2,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &       mtHZZ4fg1hvv,mtHZZ4fg2hvv,gdd,gdd,qd,qd,q1,q3,q4,q2,qhvv)

	  do 203 i1=-1,1,2
	  do 203 i2=-1,1,2
	  do 203 i3=-1,1,2
	  do 203 ig=-1,1,2
	    mats1   = 0d0
	    matt1   = 0d0
	    mats2   = 0d0
	    matt2   = 0d0
	    mats1hvv = 0d0
	    matt1hvv = 0d0
	    mats2hvv = 0d0
	    matt2hvv = 0d0
	    if (i1.eq.-i2) then
      	      mats1 = mats1 + msHZZ4fg1(i2,i3,ig)
      	      mats2 = mats2 + msHZZ4fg2(i2,i3,ig)
              if (qhvv.ne.0) then
      	        mats1hvv = mats1hvv + msHZZ4fg1hvv(i2,i3,ig)
      	        mats2hvv = mats2hvv + msHZZ4fg2hvv(i2,i3,ig)
	      endif
	    endif
	    if (i1.eq.-i3) then
      	      matt1 = matt1 + mtHZZ4fg1(i3,i2,ig)
      	      matt2 = matt2 + mtHZZ4fg2(i3,i2,ig)
              if (qhvv.ne.0) then
      	        matt1hvv = matt1hvv + mtHZZ4fg1hvv(i3,i2,ig)
      	        matt2hvv = matt2hvv + mtHZZ4fg2hvv(i3,i2,ig)
	      endif
	    endif
c*** dbar-d -ZZ-> dbar-d    
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,1,1,1) = m2aqq_gluon(1,1,1,1) 
     &	        + gs2el6*qch2*12d0*( abs(mats1)**2+abs(mats2)**2 
     &		                    +abs(matt1)**2+abs(matt2)**2) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,1,1,1) = m2aqq_gluon(1,1,1,1) 
     &	        + gs2el6*qch2*12d0*( abs(mats1hvv)**2+abs(mats2hvv)**2 
     &		                    +abs(matt1hvv)**2+abs(matt2hvv)**2) 
	    endif
	    if (qqcdnondiag.eq.1)
     &	      m2aqq_gluon(1,1,1,1) = m2aqq_gluon(1,1,1,1) 
     &	        + gs2el6*(-qchint*8d0*dreal( mats1*dconjg(matt1)
     &		                            +mats1*dconjg(matt2)
     &		                            +mats2*dconjg(matt1)
     &		                            +mats2*dconjg(matt2) ))
c*** dbar-d -Z-> sbar-s 
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,1,3,3) = m2aqq_gluon(1,1,3,3) 
     &	        + gs2el6*qch2*12d0*(abs(mats1)**2+abs(mats2)**2) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,1,3,3) = m2aqq_gluon(1,1,3,3) 
     &	        + gs2el6*qch2*12d0*(abs(mats1hvv)**2+abs(mats2hvv)**2) 
	    endif
c*** dbar-s -Z-> dbar-s 
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,3,1,3) = m2aqq_gluon(1,3,1,3) 
     &	        + gs2el6*qch2*12d0*(abs(matt1)**2+abs(matt2)**2) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
	      m2aqq_gluon(1,3,1,3) = m2aqq_gluon(1,3,1,3) 
     &	        + gs2el6*qch2*12d0*(abs(matt1hvv)**2+abs(matt2hvv)**2) 
	    endif
203	  continue
	  m2aqq_gluon(3,3,3,3) = m2aqq_gluon(1,1,1,1) 
	  m2aqq_gluon(3,3,1,1) = m2aqq_gluon(1,1,3,3)
	  m2aqq_gluon(3,1,3,1) = m2aqq_gluon(1,3,1,3)
	endif


c Type: dbar-d -> ubar-u
c-----------------------

c dbar-d -Z-> cbar-c  (k3->-p1,k4->-p2,k1->p4,k2->p3)
	if (qz.eq.1) then
          if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) call M_ZZ_gluon(
     &	     msHZZ4fg1,msHZZ4fg2,guu,gdd,qu,qd,q4,q3,q1,q2,0)
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) call M_ZZ_gluon(
     &	     msHZZ4fg1hvv,msHZZ4fg2hvv,guu,gdd,qu,qd,q4,q3,q1,q2,qhvv)
	else
	  do i1=-1,1,2
	  do i2=-1,1,2
	  do i3=-1,1,2
	    msHZZ4fg1(i1,i2,i3)    = 0d0
	    msHZZ4fg2(i1,i2,i3)    = 0d0
	    msHZZ4fg1hvv(i1,i2,i3) = 0d0
	    msHZZ4fg2hvv(i1,i2,i3) = 0d0
	  enddo
	  enddo
	  enddo
	endif

c dbar-s -W-> ubar-c  (k3->-p1,k4->p3,k1->p4,k2->-p2)
	if (qw.eq.1) then
          if ((qhvv.eq.0).or.(qqcdnondiag.eq.1)) 
     &	     call M_WW_gluon(mtHWW4fg1,mtHWW4fg2,q4,q2,q1,q3,0)    
	  if ((qhvv.ne.0).and.(qqcddiag.eq.1)) 
     &	     call M_WW_gluon(mtHWW4fg1hvv,mtHWW4fg2hvv,q4,q2,q1,q3,qhvv)    
	else
	  do i1=-1,1,2
	    mtHWW4fg1(i1)    = 0d0
	    mtHWW4fg2(i1)    = 0d0
	    mtHWW4fg1hvv(i1) = 0d0
	    mtHWW4fg2hvv(i1) = 0d0
	  enddo
	endif

	do 204 i1=-1,1,2
	do 204 i2=-1,1,2
	do 204 i3=-1,1,2
	do 204 ig=-1,1,2
	  mats1   = 0d0
	  matt1   = 0d0
	  mats2   = 0d0
	  matt2   = 0d0
	  mats1hvv = 0d0
	  matt1hvv = 0d0
	  mats2hvv = 0d0
	  matt2hvv = 0d0
	  if (i1.eq.-i2) then
      	    mats1 = mats1 + msHZZ4fg1(i2,i3,ig)
      	    mats2 = mats2 + msHZZ4fg2(i2,i3,ig)
            if (qhvv.ne.0) then
      	      mats1hvv = mats1hvv + msHZZ4fg1hvv(i2,i3,ig)
      	      mats2hvv = mats2hvv + msHZZ4fg2hvv(i2,i3,ig)
	    endif
	  endif
	  if ((i1.eq.1).and.(i2.eq.-1).and.(i3.eq.-1)) then
      	    matt1  = matt1 + mtHWW4fg1(ig)
      	    matt2  = matt2 + mtHWW4fg2(ig)
            if (qhvv.ne.0) then
      	      matt1hvv  = matt1hvv + mtHWW4fg1hvv(ig)
      	      matt2hvv  = matt2hvv + mtHWW4fg2hvv(ig)
	    endif
	  endif

 	do 204 g1=1,2
 	do 204 g2=1,2
 	do 204 g3=1,2
 	do 204 g4=1,2
 	  wmatt1 = v(g3,g1)*cv(g4,g2)*matt1
 	  wmatt2 = v(g3,g1)*cv(g4,g2)*matt2
          if (qhvv.ne.0) then
 	    wmatt1hvv = v(g3,g1)*cv(g4,g2)*matt1hvv
 	    wmatt2hvv = v(g3,g1)*cv(g4,g2)*matt2hvv
	  endif
 	  f1 = 2*g1-1
 	  f2 = 2*g2-1
 	  f3 = 2*g3
 	  f4 = 2*g4
 	  if ((f1.eq.f2).and.(f3.eq.f4)) then
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmatt1)**2+abs(wmatt2)**2 
     &		                    +abs(mats1)**2 +abs(mats2)**2 ) 
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*( abs(wmatt1hvv)**2+abs(wmatt2hvv)**2 
     &		                    +abs(mats1hvv)**2 +abs(mats2hvv)**2) 
	    endif
	    if (qqcdnondiag.eq.1)
     & 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*(-qchint*8d0*dreal( mats1*dconjg(wmatt1)
     &		                            +mats1*dconjg(wmatt2)
     &		                            +mats2*dconjg(wmatt1)
     &		                            +mats2*dconjg(wmatt2) ))
 	  else
	    if ((qhvv.eq.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmatt1)**2+abs(wmatt2)**2)
	    elseif ((qhvv.ne.0).and.(qqcddiag.eq.1)) then
 	      m2aqq_gluon(f1,f2,f3,f4) = m2aqq_gluon(f1,f2,f3,f4) 
     &	        + gs2el6*qch2*12d0*(abs(wmatt1hvv)**2+abs(wmatt2hvv)**2)
 	    endif
 	  endif
204	  continue

	end

************************************************************************
        subroutine M_WW_gluon(mH4fg1,mH4fg2,fa,fb,fc,fd,qqhvv)
************************************************************************
*       Helicity amplitudes for 
*	H -> WW -> fa + fb-bar + fc + fd-bar + gluon
*
*	qqhvv = 0/1: without/with anomalous HVV couplings
*-----------------------------------------------------------------------
*       19.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 sp(6,6),csp(6,6)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pwab,pwcd,pwabp,pwcdp,cpwab,cpwcd,cpwabp,cpwcdp
        complex*16 A10m,A01m,Aab(-1:1),Acd(-1:1)
        complex*16 A10mhvv,A10phvv
	complex*16 mH4fg1(-1:1),mH4fg2(-1:1)
        complex*16 fac
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(6,6)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkab,checkcd
        integer qqhvv

        common/prods4/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	A10m(ia,ib,ic,id,pwab,pwcd,pwabp,pwcdp) = csp(ib,id)*
     &	   pwabp*pwcd*(csp(ia,ib)*sp(ia,ic)+csp(6,ib)*sp(6,ic))
     &	      /csp(6,ia)/csp(6,ib)

	A10mhvv(ia,ib,ic,id,pwab,pwcd,pwabp,pwcdp,a1,a2,a3) = 
     &	  pwabp*pwcd/csp(6,ia)/csp(6,ib)
     &	  *( a1*csp(ib,id)*(csp(ib,ia)*sp(ia,ic)+csp(ib,6)*sp(6,ic))
     &	    +dcmplx(a2,-a3)/2d0*csp(ib,id)*sp(ic,id)
     &	     *( csp(ib,ia)*(sp(ia,ib)*csp(id,ib)+sp(ia,6)*csp(id,6))
     &	       +csp(ib,6)*(csp(id,ia)*sp(6,ia)+csp(id,ib)*sp(6,ib)) )
     &	    -dcmplx(a2,+a3)/2d0*csp(id,ic)
     &	     *( csp(ib,ia)*sp(ic,ia)+csp(ib,6)*sp(ic,6) )**2 )

	A10phvv(ia,ib,ic,id,pwab,pwcd,pwabp,pwcdp,a1,a2,a3) = 
     &	  -pwabp*pwcd/sp(6,ia)/sp(6,ib) 	
     &	  *( a1*sp(ia,ic)*(sp(ia,ib)*csp(ib,id)+sp(ia,6)*csp(6,id))
     &	    -dcmplx(a2,-a3)/2d0*sp(ic,id)
     &	     *( sp(ia,ib)*csp(ib,id)+sp(ia,6)*csp(6,id) )**2 
     &	    +dcmplx(a2,+a3)/2d0*sp(ia,ic)*csp(id,ic)
     &	     *( sp(ia,ib)*(csp(ib,ia)*sp(ic,ia)+csp(ib,6)*sp(ic,6))
     &	       +sp(ia,6)*(csp(6,ia)*sp(ic,ia)+csp(6,ib)*sp(ic,ib)) ) )

c	A01m(ia,ib,ic,id,pwab,pwcd,pwabp,pwcdp) = -csp(ib,id)*
c     &	   pwab*pwcdp*(csp(ic,id)*sp(ic,ia)+csp(6,id)*sp(6,ia))
c     &	      /csp(6,ic)/csp(6,id) 	

	sab  = vp(fa,fb)
	scd  = vp(fc,fd)
	sabp = vp(fa,fb) + vp(fa,6) + vp(fb,6)
	scdp = vp(fc,fd) + vp(fc,6) + vp(fd,6)

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pwab = 1d0/(sab-mw2)
        else
          pwab = 1d0/(sab-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pwcd = 1d0/(scd-mw2)
        else
          pwcd = 1d0/(scd-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sabp.lt.0d0))) then
          pwabp = 1d0/(sabp-mw2)
        else
          pwabp = 1d0/(sabp-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scdp.lt.0d0))) then
          pwcdp = 1d0/(scdp-mw2)
        else
          pwcdp = 1d0/(scdp-cmw2)
        endif

	checkab = ((qschan.eq.1).and.(sab.gt.0d0).and.(scdp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scdp.lt.0d0))
	checkcd = ((qschan.eq.1).and.(scd.gt.0d0).and.(sabp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(scd.lt.0d0).and.(sabp.lt.0d0))

	if (.not.checkab) pwab = 0d0
	if (.not.checkcd) pwcd = 0d0

	cpwab  = dconjg(pwab)
	cpwabp = dconjg(pwabp)
	cpwcd  = dconjg(pwcd)
	cpwcdp = dconjg(pwcdp)

	if (qqhvv.eq.0) then
	  fac = sqrt(2d0)*xmw/xsw**3
	  Aab(-1) = A10m(fa,fb,fc,fd,pwab,pwcd,pwabp,pwcdp)
c	  Aab(+1) = -dconjg(A01m(fd,fc,fb,fa,cpwcd,cpwab,cpwcdp,cpwabp))
	  Aab(+1) = -dconjg(A10m(fb,fa,fd,fc,cpwab,cpwcd,cpwabp,cpwcdp))
c	  Acd(-1) = A01m(fa,fb,fc,fd,pwab,pwcd,pwabp,pwcdp)
c	  Acd(+1) = -dconjg(A01m(fb,fa,fd,fc,cpwab,cpwcd,cpwabp,cpwcdp))
	  Acd(-1) = A10m(fc,fd,fa,fb,pwcd,pwab,pwcdp,pwabp)
	  Acd(+1) = -dconjg(A10m(fd,fc,fb,fa,cpwcd,cpwab,cpwcdp,cpwabp))
	else
	  fac     = sqrt(2d0)/xsw2
          call fixahvv(sabp,scd,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz)
	  Aab(-1) = A10mhvv(fa,fb,fc,fd,pwab,pwcd,pwabp,pwcdp,
     &			a1hww,a2hww,a3hww)
	  Aab(+1) = A10phvv(fa,fb,fc,fd,pwab,pwcd,pwabp,pwcdp,
     &			a1hww,a2hww,a3hww)
          call fixahvv(sab,scdp,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz)
	  Acd(-1) = A10mhvv(fc,fd,fa,fb,pwcd,pwab,pwcdp,pwabp,
     &			a1hww,a2hww,a3hww)
	  Acd(+1) = A10phvv(fc,fd,fa,fb,pwcd,pwab,pwcdp,pwabp,
     &			a1hww,a2hww,a3hww)
	endif

	do i1=-1,1,2
	  mH4fg1(i1) = fac*Aab(i1)
	  mH4fg2(i1) = fac*Acd(i1)
	enddo

	end

************************************************************************
        subroutine M_ZZ_gluon(mH4fg1,mH4fg2,gaz,gcz,qa,qc,fa,fb,fc,fd,
     &	                      qqhvv)
************************************************************************
*       Helicity amplitudes for 
*	H -> ZZ -> fa + fb-bar + fc + fd-bar + gluon
*
*	qqhvv = 0/1: without/with anomalous HVV couplings
*-----------------------------------------------------------------------
*       19.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 sp(6,6),csp(6,6)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pzab,pzcd,pzabp,pzcdp
        complex*16 paab,pacd,paabp,pacdp
        complex*16 pvab,pvcd,pvabp,pvcdp
        complex*16 A10mmm,A01mmm
        complex*16 A10mmmhvv,A10mmphvv,A10mpmhvv,A10mpphvv
        complex*16 Aab(-1:1,-1:1,-1:1),Acd(-1:1,-1:1,-1:1)
	complex*16 mH4fg1(-1:1,-1:1,-1:1),mH4fg2(-1:1,-1:1,-1:1)
        complex*16 gaz(-1:1),gcz(-1:1),fac,fac1,fac2
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        real*8 vp(6,6)
        integer fa,fb,fc,fd,ia,ib,ic,id,i1,i2,i3,j
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	logical checkab,checkcd
        integer qqhvv

        common/prods4/sp,csp,vp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	A10mmm(ia,ib,ic,id) = csp(ib,id)*
     &	  (csp(ia,ib)*sp(ia,ic)+csp(6,ib)*sp(6,ic))/csp(6,ia)/csp(6,ib)

c	A01mmm(ia,ib,ic,id) = -csp(ib,id)*
c     &	  (csp(ic,id)*sp(ic,ia)+csp(6,id)*sp(6,ia))/csp(6,ic)/csp(6,id) 

	A10mmmhvv(ia,ib,ic,id,a1,a2,a3) = 1d0/csp(6,ia)/csp(6,ib)
     &    *( a1*csp(ib,id)*(csp(ib,ia)*sp(ia,ic)+csp(ib,6)*sp(6,ic))
     &      +dcmplx(a2,-a3)/2d0*csp(ib,id)*sp(ic,id)
     &       *( csp(ib,ia)*(sp(ia,ib)*csp(id,ib)+sp(ia,6)*csp(id,6))
     &         +csp(ib,6)*(csp(id,ia)*sp(6,ia)+csp(id,ib)*sp(6,ib)) )
     &      -dcmplx(a2,+a3)/2d0*csp(id,ic)
     &       *( csp(ib,ia)*sp(ic,ia)+csp(ib,6)*sp(ic,6) )**2 )

	A10mpmhvv(ia,ib,ic,id,a1,a2,a3) = 1d0/csp(6,ia)/csp(6,ib)
     &	  *( a1*csp(ib,ic)*(csp(ib,ia)*sp(ia,id)+csp(ib,6)*sp(6,id))
     &	    +dcmplx(a2,-a3)/2d0*csp(ib,ic)*sp(id,ic)
     &	     *( csp(ib,ia)*(sp(ia,ib)*csp(ic,ib)+sp(ia,6)*csp(ic,6))
     &	       +csp(ib,6)*(csp(ic,ia)*sp(6,ia)+csp(ic,ib)*sp(6,ib)) )
     &	    -dcmplx(a2,+a3)/2d0*csp(ic,id)
     &	     *( csp(ib,ia)*sp(ia,id)+csp(ib,6)*sp(6,id) )**2 )

	A10mmphvv(ia,ib,ic,id,a1,a2,a3) = -1d0/sp(6,ia)/sp(6,ib) 	
     &    *( a1*sp(ia,ic)*(sp(ia,ib)*csp(ib,id)+sp(ia,6)*csp(6,id))
     &      -dcmplx(a2,-a3)/2d0*sp(ic,id)
     &       *( sp(ia,ib)*csp(ib,id)+sp(ia,6)*csp(6,id) )**2
     &      +dcmplx(a2,+a3)/2d0*sp(ia,ic)*csp(id,ic)
     &       *( sp(ia,ib)*(csp(ib,ia)*sp(ic,ia)+csp(ib,6)*sp(ic,6))
     &         +sp(ia,6)*(csp(6,ia)*sp(ic,ia)+csp(6,ib)*sp(ic,ib)) ) )

	A10mpphvv(ia,ib,ic,id,a1,a2,a3) = -1d0/sp(6,ia)/sp(6,ib) 	
     &	  *( a1*sp(ia,id)*(sp(ia,ib)*csp(ib,ic)+sp(ia,6)*csp(6,ic))
     &	    -dcmplx(a2,-a3)/2d0*sp(id,ic)
     &	     *( sp(ia,ib)*csp(ib,ic)+sp(ia,6)*csp(6,ic) )**2 
     &	    +dcmplx(a2,+a3)/2d0*sp(ia,id)*csp(ic,id)
     &	     *( sp(ia,ib)*(csp(ib,ia)*sp(id,ia)+csp(ib,6)*sp(id,6))
     &	       +sp(ia,6)*(csp(6,ia)*sp(id,ia)+csp(6,ib)*sp(id,ib)) ) )

	sab  = vp(fa,fb)
	scd  = vp(fc,fd)
	sabp = vp(fa,fb) + vp(fa,6) + vp(fb,6)
	scdp = vp(fc,fd) + vp(fc,6) + vp(fd,6)

        paab  = 1d0/sab
        pacd  = 1d0/scd
        paabp = 1d0/sabp
        pacdp = 1d0/scdp

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sab.lt.0d0))) then
          pzab = 1d0/(sab-mz2)
        else
          pzab = 1d0/(sab-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scd.lt.0d0))) then
          pzcd = 1d0/(scd-mz2)
        else
          pzcd = 1d0/(scd-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(sabp.lt.0d0))) then
          pzabp = 1d0/(sabp-mz2)
        else
          pzabp = 1d0/(sabp-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(scdp.lt.0d0))) then
          pzcdp = 1d0/(scdp-mz2)
        else
          pzcdp = 1d0/(scdp-cmz2)
        endif

	checkab = ((qschan.eq.1).and.(sab.gt.0d0).and.(scdp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(sab.lt.0d0).and.(scdp.lt.0d0))
	checkcd = ((qschan.eq.1).and.(scd.gt.0d0).and.(sabp.gt.0d0))
     &	     .or. ((qtchan.eq.1).and.(scd.lt.0d0).and.(sabp.lt.0d0))

	if (.not.checkab) then
	  paab = 0d0
	  pzab = 0d0
	endif
	if (.not.checkcd) then
	  pacd = 0d0
	  pzcd = 0d0
	endif

	if (qqhvv.eq.0) then

	fac1 = 2d0*sqrt(2d0)*xmw/xcw2/xsw * pzabp*pzcd
	fac2 = 2d0*sqrt(2d0)*xmw/xcw2/xsw * pzab *pzcdp

	Aab(-1,-1,-1) = A10mmm(fa,fb,fc,fd)
	Aab(+1,-1,-1) =-A10mmm(fb,fa,fc,fd)
	Aab(-1,+1,-1) = A10mmm(fa,fb,fd,fc)
	Aab(+1,+1,-1) =-A10mmm(fb,fa,fd,fc)
	Aab(+1,+1,+1) = dconjg(A10mmm(fa,fb,fc,fd))
	Aab(-1,+1,+1) =-dconjg(A10mmm(fb,fa,fc,fd))
	Aab(+1,-1,+1) = dconjg(A10mmm(fa,fb,fd,fc))
	Aab(-1,-1,+1) =-dconjg(A10mmm(fb,fa,fd,fc))

c	Acd(-1,-1,-1) = A01mmm(fa,fb,fc,fd)
c	Acd(+1,-1,-1) = A01mmm(fb,fa,fc,fd)
c	Acd(-1,+1,-1) =-A01mmm(fa,fb,fd,fc)
c	Acd(+1,+1,-1) =-A01mmm(fb,fa,fd,fc)
c	Acd(+1,+1,+1) = dconjg(A01mmm(fa,fb,fc,fd))
c	Acd(-1,+1,+1) = dconjg(A01mmm(fb,fa,fc,fd))
c	Acd(+1,-1,+1) =-dconjg(A01mmm(fa,fb,fd,fc))
c	Acd(-1,-1,+1) =-dconjg(A01mmm(fb,fa,fd,fc))

	Acd(-1,-1,-1) = A10mmm(fc,fd,fa,fb)
	Acd(+1,-1,-1) = A10mmm(fc,fd,fb,fa)
	Acd(-1,+1,-1) =-A10mmm(fd,fc,fa,fb)
	Acd(+1,+1,-1) =-A10mmm(fd,fc,fb,fa)
	Acd(+1,+1,+1) = dconjg(A10mmm(fc,fd,fa,fb))
	Acd(-1,+1,+1) = dconjg(A10mmm(fc,fd,fb,fa))
	Acd(+1,-1,+1) =-dconjg(A10mmm(fd,fc,fa,fb))
	Acd(-1,-1,+1) =-dconjg(A10mmm(fd,fc,fb,fa))

	do i1=-1,1,2
	do i2=-1,1,2
	do i3=-1,1,2
	  mH4fg1(i1,i2,i3) = fac1*gaz(i1)*gcz(i2)*Aab(i1,i2,i3)
	  mH4fg2(i1,i2,i3) = fac2*gaz(i1)*gcz(i2)*Acd(i1,i2,i3)
	enddo
	enddo
	enddo

	else

	do i1=-1,1,2
	do i2=-1,1,2
	do i3=-1,1,2
	  mH4fg1(i1,i2,i3) = 0d0
	  mH4fg2(i1,i2,i3) = 0d0
	enddo
	enddo
	enddo

        call fixahvv(sabp,scd,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz)
        call fixahvv(sab,scdp,
     &             xa1hww,xa2hww,xa3hww,xa1haa,xa2haa,xa3haa,
     &             xa1haz,xa2haz,xa3haz,xa1hzz,xa2hzz,xa3hzz)

	do 100 j=1,3

	if (j.eq.1) then
	  a1  = a1haa
	  a2  = a2haa
	  a3  = a3haa
	  xa1 = xa1haa
	  xa2 = xa2haa
	  xa3 = xa3haa
	elseif (j.eq.2) then
	  a1  = a1haz
	  a2  = a2haz
	  a3  = a3haz
	  xa1 = xa1haz
	  xa2 = xa2haz
	  xa3 = xa3haz
	elseif (j.eq.3) then
	  a1  = a1hzz
	  a2  = a2hzz
	  a3  = a3hzz
	  xa1 = xa1hzz
	  xa2 = xa2hzz
	  xa3 = xa3hzz
	endif

	Aab(-1,-1,-1) = A10mmmhvv(fa,fb,fc,fd,a1,a2,a3)
	Aab(-1,+1,-1) = A10mpmhvv(fa,fb,fc,fd,a1,a2,a3)
	Aab(-1,-1,+1) = A10mmphvv(fa,fb,fc,fd,a1,a2,a3)
	Aab(-1,+1,+1) = A10mpphvv(fa,fb,fc,fd,a1,a2,a3)
	Aab(+1,+1,+1) = dconjg(A10mmmhvv(fa,fb,fc,fd,a1,a2,a3))
	Aab(+1,-1,+1) = dconjg(A10mpmhvv(fa,fb,fc,fd,a1,a2,a3))
	Aab(+1,+1,-1) = dconjg(A10mmphvv(fa,fb,fc,fd,a1,a2,a3))
	Aab(+1,-1,-1) = dconjg(A10mpphvv(fa,fb,fc,fd,a1,a2,a3))

	Acd(-1,-1,-1) = A10mmmhvv(fc,fd,fa,fb,xa1,xa2,xa3)
	Acd(+1,-1,-1) = A10mpmhvv(fc,fd,fa,fb,xa1,xa2,xa3)
	Acd(-1,-1,+1) = A10mmphvv(fc,fd,fa,fb,xa1,xa2,xa3)
	Acd(+1,-1,+1) = A10mpphvv(fc,fd,fa,fb,xa1,xa2,xa3)
	Acd(+1,+1,+1) = dconjg(A10mmmhvv(fc,fd,fa,fb,xa1,xa2,xa3))
	Acd(-1,+1,+1) = dconjg(A10mpmhvv(fc,fd,fa,fb,xa1,xa2,xa3))
	Acd(+1,+1,-1) = dconjg(A10mmphvv(fc,fd,fa,fb,xa1,xa2,xa3))
	Acd(-1,+1,-1) = dconjg(A10mpphvv(fc,fd,fa,fb,xa1,xa2,xa3))

	do i1=-1,1,2
	do i2=-1,1,2
	do i3=-1,1,2
	  if (j.eq.1) then
	    fac1 = 2d0*sqrt(2d0)*(-qa)*(-qc) * paabp*pacd
	    fac2 = 2d0*sqrt(2d0)*(-qa)*(-qc) * paab *pacdp
	  elseif (j.eq.2) then
	    fac1 = 2d0*sqrt(2d0)*( (-qa)*gcz(i2)*paabp*pzcd
     &	                          +gaz(i1)*(-qc)*pzabp*pacd )
	    fac2 = 2d0*sqrt(2d0)*( (-qa)*gcz(i2)* paab*pzcdp
     &	                          +gaz(i1)*(-qc)* pzab*pacdp )
	  elseif (j.eq.3) then
	    fac1 = 2d0*sqrt(2d0)*gaz(i1)*gcz(i2) * pzabp*pzcd
	    fac2 = 2d0*sqrt(2d0)*gaz(i1)*gcz(i2) * pzab *pzcdp
	  endif
	  mH4fg1(i1,i2,i3) = mH4fg1(i1,i2,i3) + fac1*Aab(i1,i2,i3)
	  mH4fg2(i1,i2,i3) = mH4fg2(i1,i2,i3) + fac2*Acd(i1,i2,i3)
	enddo
	enddo
	enddo

100	continue

	endif

	end

************************************************************************
        subroutine Mat2conv(ecms,p,x,m2i,m2if,mfact)
************************************************************************
*       Convolution contribution for subtraction function for
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5)
*-----------------------------------------------------------------------
*       15.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        complex*16 guu,gdd,gnn,gll
        real*8 p(6,0:3),qp(-4:4),mp2(-4:4),s(6,6)
        real*8 m2i0(-5:5,-5:5),m2i(-5:5,-5:5)
        real*8 m2if0(-5:5,-5:5,-5:5,-5:5),m2if(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
        real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
	integer i1,i2,i3,i4,j1,j2,i,j,k
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        COMMON/IR/LAMBDA,LAMBDA2

        pqq(a)       = (1d0+a**2)/(1d0-a)
        Gab(p2,m2,a) = pqq(a)*(log(p2/m2)-1d0)+1d0-a
        Gia(a)       = (2d0*log((2d0-a)/(1d0-a))-3d0/2d0)/(1d0-a)
        Gai(p2,m2,a) = pqq(a)*(log(p2/m2/a)-1d0)-2d0/(1d0-a)*log(2d0-a)
     &                +(1d0+a)*log(1d0-a)+1d0-a
        h(m2,a)      = pqq(a)*(log(mfact**2/m2)-2d0*log(1d0-a)-1d0)
        hdis(m2,a)   = pqq(a)*(log(mfact**2/m2)-log(a*(1d0-a)))
     &                  +3d0*a+4d0-7d0/2d0/(1d0-a)

	qp(1) = qd
	qp(2) = qu
	qp(3) = qd
	qp(4) = qu
	mp2(1) = md2
	mp2(2) = mu2
	mp2(3) = md2
	mp2(4) = mu2
	do i=1,4
	  qp(-i)  = -qp(i)
	  mp2(-i) = mp2(i)
	enddo

	do 100 i=1,5
	do 100 j=1,5
	  s(i,j) = 2d0*( p(i,0)*p(j,0)-p(i,1)*p(j,1)
     &		        -p(i,2)*p(j,2)-p(i,3)*p(j,3) )
100	continue

        call Mat2born(p,m2i0,m2if0,
     &                m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

        do 200 i1=-4,4
        do 200 i2=-4,4
          m2i(i1,i2) = 0d0
          if (i1*i2.eq.0) goto 200
        do 300 j1=1,4
        do 300 j2=1,4
	  i3 = sign(j1,i1)
	  i4 = sign(j2,i2)
	  if (nint(qp(i1)+qp(i2)-qp(i3)-qp(i4)).ne.0) goto 300
	  m2if(i1,i2,i3,i4) = 0d0
	  if (qbos.ne.0) then
	    m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	      -alpha/2d0/pi*m2if0(i1,i2,i3,i4)*(
     &	         qp(i1)*qp(i2)*( Gab(ecms**2,mp2(i1),x)
     &	                        +Gab(ecms**2,mp2(i2),x) )
     &	        -qp(i1)*qp(i3)*( Gia(x)+Gai(s(1,3),mp2(i1),x) )
     &	        -qp(i2)*qp(i4)*( Gia(x)+Gai(s(2,4),mp2(i2),x) )
     &	        -qp(i1)*qp(i4)*( Gia(x)+Gai(s(1,4),mp2(i1),x) )
     &	        -qp(i2)*qp(i3)*( Gia(x)+Gai(s(2,3),mp2(i2),x) ) )
	    if (qfact.eq.1) then
	      m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &          -alpha/2d0/pi*m2if0(i1,i2,i3,i4)
     &	  	  *( qp(i1)**2*hdis(mp2(i1),x)
     &		    +qp(i2)**2*hdis(mp2(i2),x) )
	    endif
	  endif
	  if (qqcddiag.ne.0) then
	    m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &	      -alphas*2d0/3d0/pi*(
     &	        + sign(1,i1*i2)*( Gab(ecms**2,mp2(i1),x)
     &                           +Gab(ecms**2,mp2(i2),x) )
     &	          *m2if0_22(i1,i2,i3,i4)
     &	        - ( sign(1,i1*i3)*( Gia(x)+Gai(s(1,3),mp2(i1),x) )
     &	           +sign(1,i2*i4)*( Gia(x)+Gai(s(2,4),mp2(i2),x) ) )
     &	          *m2if0_33(i1,i2,i3,i4) 				  
     &	        - ( sign(1,i1*i4)*( Gia(x)+Gai(s(1,4),mp2(i1),x) )
     &	           +sign(1,i2*i3)*( Gia(x)+Gai(s(2,3),mp2(i2),x) ) )
     &	          *m2if0_44(i1,i2,i3,i4)	   			  )
	    if (qfact.eq.1) then
	      m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &          -alphas*2d0/3d0/pi
     &		  *( m2if0_22(i1,i2,i3,i4)+m2if0_33(i1,i2,i3,i4)
     &		    +m2if0_44(i1,i2,i3,i4) )
     &	  	  *( h(mp2(i1),x)+h(mp2(i2),x) )
	    endif
	  endif
	  if (qqcdnondiag.ne.0) then
	    m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &        -alphas*2d0/3d0/pi*m2if0_nd(i1,i2,i3,i4)*(
     &           sign(1,i1*i2)*( Gab(ecms**2,mp2(i1),x)
     &                          +Gab(ecms**2,mp2(i2),x) )
     &          -sign(1,i1*i3)*( Gia(x)+Gai(s(1,3),mp2(i1),x) )
     &          -sign(1,i2*i4)*( Gia(x)+Gai(s(2,4),mp2(i2),x) )
     &          -sign(1,i1*i4)*( Gia(x)+Gai(s(1,4),mp2(i1),x) )
     &          -sign(1,i2*i3)*( Gia(x)+Gai(s(2,3),mp2(i2),x) ) )
	    if (qfact.eq.1) then
	      m2if(i1,i2,i3,i4) = m2if(i1,i2,i3,i4)
     &          -alphas*2d0/3d0/pi*m2if0_nd(i1,i2,i3,i4)
     &	  	  *( h(mp2(i1),x)+h(mp2(i2),x) )
	    endif
	  endif
          m2i(i1,i2) = m2i(i1,i2) + m2if(i1,i2,i3,i4)
300     continue
200     continue

	end

********************************************************************************
        function ics_conv(ec)
********************************************************************************
*       Integrated convolution part of NLO correction 
*-------------------------------------------------------------------------------
*       18.10.2006 Stefan Dittmaier
********************************************************************************
        implicit real*8 (a-z)
        integer ncall,itmx

        common/ppecms/ppecms
        common/result/s1,s2,s3,s4
        common/vegpar/ncall,itmx

        external dcs_conv

        ppecms = ec

        ics_conv = intveg(dcs_conv,7,ncall,itmx)

        end

********************************************************************************
        function dcs_conv(x,wgt)
********************************************************************************
*       Differential cross section
*-------------------------------------------------------------------------------
*       18.10.2006 Stefan Dittmaier
********************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
        real*8 x(10),p(6,0:3),px(6,0:3),pdf1(-6:6),pdf2(-6:6)
        real*8 m2i(-5:5,-5:5),mx2i(-5:5,-5:5)
        real*8 m2if(-5:5,-5:5,-5:5,-5:5),mx2if(-5:5,-5:5,-5:5,-5:5)
        integer i1,i2
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/GEVFB/GEVFB
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/ppecms/ppecms
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	eps = 1d-5

        x5 = eps + (1d0-2d0*eps)*x(5)
        x6 = eps + (1d0-2d0*eps)*x(6)
        x7 = eps + (1d0-2d0*eps)*x(7)

        tau0  = (mh/ppecms)**2
        tau   = tau0**x5
        xp1   = tau**x6
        jact  = tau*log(tau0)*log(tau)
c       tau   = tau0+x5*(1d0-tau0)
c       xp1   = tau+(1d0-tau)*x6
c       jact  = (1d0-tau0)*(1d0-tau)/xp1

        tau   = tau0**x5
        xp1   = tau+(1d0-tau)*x6
        jact  = -tau*log(tau0)*(1d0-tau)/xp1
        xp2   = tau/xp1
        ecms  = sqrt(tau)*ppecms

	xx    = x7
	ecmsx = sqrt(xx)*ecms

        call phsp3gen(ecms,p,x,jac)
        jac1 = jac*4d0*pi*jact
	if (ecmsx/mh-1d0.gt.eps) then
          call phsp3gen(ecmsx,px,x,jac)
          jacx = jac*4d0*pi*jact
	endif

cxxx
c pT cuts on jets
c	ptjetmin = 10d0
c	if ((e1*sth1.lt.ptjetmin).or.(e2*sth2.lt.ptjetmin)) then
c	  dcs = 0d0
c	  return
c	endif

c PDFs
	mfact  = mh
        call wpdf_sd(xp1,mfact,pdf1,pdf_phot1,1)
        call wpdf_sd(xp2,mfact,pdf2,pdf_phot2,1)

c squared matrix elements
        call Mat2conv(ecms,p,xx,m2i,m2if,mfact)
	if (ecmsx/mh-1d0.gt.eps) 
     &	  call Mat2conv(ecms,px,xx,mx2i,mx2if,mfact)

c weighted |M|^2
	wmat2 = 0d0
	do 100 i1=-4,4
	do 100 i2=-4,4
	  if (i1*i2.eq.0) goto 100
	  if (ecmsx/mh-1d0.gt.eps)
     &	    wmat2 = wmat2 + mx2i(i1,i2)/xx*jacx*pdf1(i1)*pdf2(i2) 
	  wmat2 = wmat2 - m2i(i1,i2)*jac1*pdf1(i1)*pdf2(i2) 
100	continue

        dcs_conv = GEVFB/pi**4/256d0/ecms**2*wmat2/36d0

	if (abs(dcs_conv).lt.1d30) return

999	format(10g26.16)
	write(*,999) x
	write(*,*) 'dcs_conv ',dcs_conv
	write(*,*) 'wmat2    ',wmat2    
	stop

	end


